package com.muyu.mysql;

import com.muyu.mysql.confilg.MySqlConfilg;
import com.muyu.mysql.dto.Mysql;
import lombok.extern.log4j.Log4j2;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * mysql测试 MysqlApp
 *
 * @author LeYang
 * on 2024/5/10
 */
@SpringBootApplication
@Log4j2
public class MysqlApp {
    public static void main(String[] args) {
        HashMap<String, Object> hashMap = new HashMap<>();
        List<Mysql> mySqlConfigs = new ArrayList<>();

        Mysql mysql = new Mysql();
        mysql.setId("1");
        mysql.setName("root");
        mysql.setSystemName("2222");
        mysql.setUsername("root");
        mysql.setPassword("root");
        mysql.setHost("127.0.0.1");
        mysql.setDatabaseName("damo01");
        mysql.setPort("3306");
        mysql.setType("Mysql");
        mysql.setDriverName("com.mysql.cj.jdbc.Driver");
        mysql.setConnectionParam("useUnicode=true&characterEncoding=utf8&zeroDateTimeBehavior=convertToNull&useSSL=true&serverTimezone=GMT%2B8");

        mySqlConfigs.add(mysql);

        mySqlConfigs.forEach(mysql1 -> {
            MySqlConfilg build = MySqlConfilg.builder()
                    .id(mysql1.getId())
                    .name(mysql1.getName())
                    .userName(mysql1.getUsername())
                     .password(mysql1.getPassword())
                    .databaseName(mysql1.getDatabaseName())
                    .port(mysql1.getPort())
                    .type(mysql1.getType())
                    .driverName(mysql1.getDriverName())
                    .param(mysql1.getConnectionParam())
                    .ip(mysql1.getHost())
                    .build();

            MySqlConnect<Connection> mySqlConnect = new MysqlConnectionInformation(build);
            Connection conn = mySqlConnect.getConn(build);
            try {
                Statement statement = conn.createStatement();
                ResultSet resultSet = statement.executeQuery("SHOW TABLES");
                while (resultSet.next()){
                    String string = resultSet.getString(1);
                    log.info("name:{}",string);
                }
                log.info("连接成功");
                mySqlConnect.closeConn();
            } catch (SQLException e) {
                throw new RuntimeException(e);
            }
        });

    }
}
